package com.inxar.jenesis;

/**
 * $Id: Javac.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
import java.io.*;
import java.util.Vector;
import java.util.StringTokenizer;
import sun.tools.javac.Main;
import org.inxar.jenesis.*;
import com.inxar.jenesis.*;
import com.inxar.jenesis.util.*;

/**
 * Implementation of <code>VirtualCompiler</code> which calls
 * <code>sun.tools.javac.Main.compile()</code>.  
 */
public class Javac
	extends MVC
{
    /**
     * Constructs a new Javac compiler instance.
     */
    public Javac()
    {
	super();
    }
    public boolean compile(CompilationUnit unit) throws java.io.IOException
    {
	// Get the path separator (unix = ':', dos = ';').
	String sep = System.getProperty("path.separator");

	StringBuffer args = new StringBuffer();

	// Then add the destination
	if (dest != null)
	    args.append(" -d ").append(dest);

	// Append all the sourcepath arguments
	if (srcs.size() > 0) {
	    args.append(" -sourcepath");
	}

	// Then finally do the classpath
        args.append(" -classpath ").append(unit.getCodebase());

	// Append all the classpath and sourcepath arguments
	for (int i = 0; i < libs.size(); i++)
	    args.append(sep).append((String)libs.elementAt(i));
	for (int i = 0; i < srcs.size(); i++) {
	    args.append((String)libs.elementAt(i));
	}

	// Start off with adding the options
	for (int i = 0; i < opts.size(); i++)
	    args.append((String)opts.elementAt(i));

        // Add the filename of the unit to compile.
	args.append(' ').append(toFilename(unit));

	// And compile it.
	return new Main(System.out, "javac").compile(split(args.toString(), " "));
    }
}
