package com.inxar.jenesis.util;

/**
 * $Id: BlockStyle.java,v 1.1 2003-08-25 12:31:55 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
import org.inxar.jenesis.*;

/**
 * BlockStyle is an interface whose implementations encapsulate the
 * ability to render an array of codeable objects with surrounding
 * braces.  This is applicable for a number of stuctures including
 * some declarations (classes, methods...) and block statements.  This
 * allows a sort of 'plug and play' approach to brace styles.  
 */
public interface BlockStyle
{
    /**
     * Sets an iterator of codeables to write as a block.
     */
    void toCode(CodeWriter out, Iterator iterator);
}
