package org.inxar.jenesis;

/**
 * $Id: Access.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * Classes that implement this interface are access controllable
 * according to the Java Language Specification.  These include
 * classes, interfaces, fields, methods, and constructors. 
 */
public interface Access
{
	/**
	 * Constant to indicate public access.
	 */
	static final int PUBLIC = 1;

	/**
	 * Constant to indicate package access.
	 */
	static final int PACKAGE = 2;

	/**
	 * Constant to indicate protected access.
	 */
	static final int PROTECTED = 3;

	/**
	 * Constant to indicate private access.
	 */
	static final int PRIVATE = 4;
	
    /**
     * Gets the access level as one of the constants in this
     * interface.  
     */
    int getAccess();
    /**
     * Sets the access level according to the given constant.
     */
    void setAccess(int level);
}
