package org.inxar.jenesis;

/**
 * $Id: Accessor.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Expression</code> subinterface for expressions which access
 * data including field accesses, array accesses, and method
 * invocations.  An <code>Accessor</code> expression has two parts
 * with the general form <qualifier> dot <name>.  The qualifier
 * references the handle to object where the resource resides and the
 * name references the name of the resource.  For example, in
 * <code>this.id</code>, <code>this</code> is the qualifier and
 * <code>id</code> is the name. The qualifier is optional, in which
 * case the <code>Accessor</code> will render without the dot.  
 */
public interface Accessor
	extends Variable
{
    /**
     * Sets the qualified name of the resource container object.  
     */
    String getQualifier();
    /**
     * Sets the qualified name of the resource container object.
     */
    void setQualifier(String name);
}
