package org.inxar.jenesis;

/**
 * $Id: ArrayAccess.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Expression</code> subinterface for array accesses.  An
 * <code>ArrayAccess</code> expression specifies the element in an
 * (potentially) multidimensional array.  For example, to say
 * <code>myArray[2][2][i]</code>, you might do:
 *
 * <pre>
 * arrayAccess.setName("myArray");
 * arrayAccess.addDim(intLiteral_2);
 * arrayAccess.addDim(intLiteral_2);
 * arrayAccess.addDim(reference_i);
 * </pre> 
 */
public interface ArrayAccess
extends Accessor
{
   /**
    * Adds the given expression for the next dimension.
    */
   ArrayAccess addDim(Expression expr);
   /**
    * Returns a list of dimension-specifying expressions as an
    * iterator of <code>Expression</code>.  
    */
   Iterator getDims();
}
