package org.inxar.jenesis;

/**
 * $Id: Comment.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * The <code>Comment</code> superinterface.
 */
public interface Comment
extends Codeable
{
	/**
	 * Type constant for a single line comment.
	 */
	static final int S = 1;

	/**
	 * Type constant for a multiple line comment.
	 */
	static final int M = 2;

	/**
	 * Type constant for a multiple line comment, but only at the beginning and at the end.
	 */
	static final int Mbe = 3;

	/**
	 * Type constant for a documentation comment.
	 */
	static final int D = 4;

	/**
	 * Gets the text for this comment.
	 */
	String getText();
	/**
	 * Sets the text for this comment.
	 */
	void setText(String text);
	/**
	 * Returns the type of this comment.
	 */
	int type();
}
