package org.inxar.jenesis;

/**
 * $Id: Constructor.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Declaration</code> subinterface for a class constructor.
 */
public interface Constructor
extends Access, InitializationDeclaration
{
	/**
	 * Adds a new formal parameter to the list of parameters with the given <code>Type</code> and
	 * name, andm returns the <code>FormalParameter</code> object.
	 */
	FormalParameter addParameter(Type type, String name);
	/**
	 * Adds this string to the list of throws.
	 */
	void addThrows(String type);
	/**
	 * Gets the list of formal parameters as an iterator of <code>FormalParameter</code>.
	 */
	Iterator getParameters();
	/**
	 * Gets the list of throws clauses as an iterator of <code>String</code>.
	 */
	Iterator getThrows();
}
