package org.inxar.jenesis;

/**
 * $Id: DocumentationComment.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Comment</code> subinterface for documentation comments
 * (javadoc).  
 */
public interface DocumentationComment
extends Comment
{
    /**
     * Adds a <code>param</code> tag to the list of <code>param</code>
     * tags.  
     */
    void addParam(String s);
    /**
     * Adds a <code>see</code> tag to the list of <code>see</code>
     * tags.  
     */
    void addSee(String s);
    /**
     * Returns the <code>author</code> tag.
     */
    String getAuthor();
    /**
     * Returns the <code>date</code> tag.
     */
    String getDate();
    /**
     * Returns the <code>deprecated</code> tag.
     */
    String getDeprecated();
    /**
     * Returns the <code>exception</code> tag.
     */
    String getException();
    /**
     * Returns an <code>Iterator</code> of <code>String</code> over
     * the list of <code>param</code> tags.  
     */
    Iterator getParams();
    /**
     * Returns the <code>return</code> tag.
     */
    String getReturn();
    /**
     * Returns an <code>Iterator</code> of <code>String</code> over
     * the list of <code>see</code> tags.  
     */
    Iterator getSees();
    /**
     * Returns the <code>serial</code> tag.
     */
    String getSerial();
    /**
     * Returns the <code>serialData</code> tag.
     */
    String getSerialData();
    /**
     * Returns the <code>serialField</code> tag.
     */
    String getSerialField();
    /**
     * Returns the <code>since</code> tag.
     */
    String getSince();
    /**
     * Returns the <code>throws</code> tag.
     */
    String getThrows();
    /**
     * Returns the <code>version</code> tag.
     */
    String getVersion();
    /**
     * Sets the <code>author</code> tag.
     */
    void setAuthor(String s);
    /**
     * Sets the <code>datew</code> tag.
     */
    void setDate(String s);
    /**
     * Sets the <code>deprecated</code> tag.
     */
    void setDeprecated(String s);
    /**
     * Sets the <code>exception</code> tag.
     */
    void setException(String s);
    /**
     * Sets the <code>return</code> tag.
     */
    void setReturn(String s);
    /**
     * Sets the <code>serial</code> tag.
     */
    void setSerial(String s);
    /**
     * Sets the <code>serialData</code> tag.
     */
    void setSerialData(String s);
    /**
     * Sets the <code>serialField</code> tag.
     */
    void setSerialField(String s);
    /**
     * Sets the <code>since</code> tag.
     */
    void setSince(String s);
    /**
     * Sets the <code>throws</code> tag.
     */
    void setThrows(String s);
    /**
     * Sets the <code>version</code> tag.
     */
    void setVersion(String s);
}
