package org.inxar.jenesis;

/**
 * $Id: Interface.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Declaration</code> subinterface for interfaces.
 */
public interface Interface
	extends TypeDeclaration
{
    /**
     * Adds the given string to the list of extends clauses and
     * returns the <code>Interface</code>.  
     */
    Interface addExtends(String type);
    /**
     * Gets the list of extends clauses as an iterator of
     * <code>String</code>.  
     */
    Iterator getExtends();
    /**
     * Adds a new int constant to this interface with the given name
     * and value.  This is a convenience method.  
     */
    Constant newConstant(String name, int value);
    /**
     * Adds a new constant to this interface.
     */
    Constant newConstant(Type type, String name);
    /**
     * Adds a new abstract method signature to this interface.  
     */
    AbstractMethod newMethod(Type type, String name);
}
