package org.inxar.jenesis;

/**
 * $Id: Let.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Statement</code> subinterface for local variable
 * declarations.  Although of course 'let' is not a keyword, the
 * concept implied by the let keyword in other languages encapsulates
 * the idea here.  Multiple variables of the same type can be
 * initialized in the same <code>Let</code>.  
 */
public interface Let
extends Statement
{
    /**
     * Adds a new assignment to this variable declaration.
     */
    void addAssign(String name, Expression expr);
    /**
     * Gets the list of comma separated assignments as an iterator of
     * <code>Assign</code>.  
     */
    Iterator getAssigns();
    /**
     * Gets the type for this declaration.
     */
    Type getType();
    /**
     * Getter method for the isFinal flag.
     */
    boolean isFinal();
    /**
     * Setter method for the isFinal flag.  
     */
    void isFinal(boolean value);
    /**
     * Sets the type for this declaration.
     */
    void setType(Type expr);
}
