package org.inxar.jenesis;

/**
 * $Id: Member.java,v 1.2 2006-02-16 21:59:50 wee Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Declaration</code> subinterface for other declaration
 * structures which may belong to a class / interface.  These include
 * fields, methods, and inner classes.  
 */
public interface Member
	extends Access, Declaration
{
    /**
     * Gets the identifier for this member.
     */
    String getName();
    /**
     * Accessor method for the isFinal flag.
     */
    boolean isFinal();
    /**
     * Mutator method for the isFinal flag.
     */
    void isFinal(boolean value);
    /**
     * Accessor method for the isStatic flag.
     */
    boolean isStatic();
    /**
     * Mutator method for the isStatic flag.
     */
    void isStatic(boolean value);
    /**
     * Sets the identifier for this member.
     */
    void setName(String identifier);
    
	Iterator getAnnotations(); 

	Annotation addAnnotation(String text);
    
	Annotation addAnnotation(String name, String text);
	
	void addAnnotation(Annotation annotation);
}
