package org.inxar.jenesis;

/**
 * $Id: NewArray.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Expression</code> subinterface for expressions which create
 * new arrays.  
 */
public interface NewArray
	extends Expression
{
    /**
     * Sets the given dimension without an argument ([]).  
     */
    NewArray addDim();
    /**
     * Sets the given expression for the given dimension. To specify a
     * dimension without an argument, set the expr to
     * <code>null</code>.  
     */
    NewArray addDim(Expression e);
    /**
     * Gets the list of dimension expressions as an iterator of
     * <code>Expression</code>.  
     */
    Iterator getDims();
    /**
     * Gets the array initialization expression.
     */
    ArrayInitializer getInitializer();
    /**
     * Sets the array initialization expressions as an arbitrarily
     * nested array[n] of expressions.  
     */
    void setInitializer(ArrayInitializer ai);
   /**
    * Sets the given type for this array creation.  The Type
    * should be a class or primitive type, not an array type.
    */
   void setType(Type type);
}
