package org.inxar.jenesis;

/**
 * $Id: NewClass.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Expression</code> subinterface for expressions which create
 * new non-array objects.  
 */
public interface NewClass
	extends Expression
{
    /**
     * Adds the given expression the list of arguments for this new
     * invocation.  
     */
    NewClass addArg(Expression e);
    /**
     * Gets the list of arguments for this instance creation as an
     * iterator of <code>Expression</code>.  
     */
    Iterator getArgs();
    /**
     * Sets the qualifier for this instance creation.
     */
    String getQualifier();
    /**
     * Sets the qualifier for this instance creation. This is a
     * feature needed only when expressing instance creation of a
     * non-static inner class.  Typically it will remain null.  
     */
    void setQualifier(String s);
    /**
     * Sets the given type for this instance creation.
     */
    void setType(Type type);
}
