package org.inxar.jenesis;

/**
 * $Id: Try.java,v 1.1 2003-08-25 12:31:54 pra Exp $
 *
 * Copyright (C) 2000, 2001  Paul Cody Johnston - pcj@inxar.org
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
/**
 * <code>Statement</code> subinterface for the <code>try catch
 * finally</code> construct.  
 */
public interface Try
	extends Statement, Block
{
    /**
     * Gets the list of catches as an iterator of <code>Catch</code>.
     */
    Iterator getCatches();
    /**
     * Gets the optional <code>Finally</code> statement.
     */
    Finally getFinally();
    /**
     * Adds a new <code>Catch</code> statement to this <code>Try</code>.
     */
    Catch newCatch(Type type, String name);
}
